import { useState, useEffect, useRef } from 'react'

import Taro from '@tarojs/taro'
import { View, Picker, Image, ScrollView } from '@tarojs/components'
import CouponCard from '@/components/CouponCard'
import { compressImage } from '@/utils'
import SaveIcon from '@/components/SaveIcon'
import grassOFF from '@/assets/icons/housemantj/grassOFF.png'
import grassNO from '@/assets/icons/housemantj/grassNO.png'
import Popup from '@/components/Popup'
import { saveTravel, newTravelMine, getTravelMine } from '@/services/travel'

import './style.less'


const CouponMedia = CouponCard.Media
const Action = CouponCard.Action

//套餐卡片
export default (props) => {
  const { item, st, editable, setScroll, goshop, travelMine, travelMineContent } = props
  // const travelId = travelMineContent?.records[0]?.travelId
  const { targetId } = props.item
  const goFood = () => {
    Taro.navigateTo({ url: `/pages/details/foodDetails/foodDetails?id=${targetId}` })

  }
  const [showCutover, setShowCutover] = useState(false)
  const [valueList, setValueList] = useState([])


  useEffect(() => {
    setValueList(travelMine?.records)


  }, [travelMine?.records])

  const onClose = () => {
    //关闭当前套餐详情弹窗
    setShowCutover(false)
    //使父组件恢复滚动
    setScroll(true)
  }

  //列改变
  const [traveCoumun, setTraveCoumun] = useState()


  const numberTrave = (new Array(traveCoumun).fill()).map((_, index) => ({ id: index + 1, title: `第 ${index + 1} 天` }))

  const array = [valueList, numberTrave]


  const handleColumn = e => {
    // console.log(e.detail.column);

    const { column, value } = e.detail


    const firstValue = valueList[value]
    console.log("🚀 ~ file: index.jsx ~ line 61 ~ firstValue", firstValue)
    setTraveCoumun(firstValue.dayNum)

  }



  const day = new Date();
  const y = day.getFullYear();
  const m = day.getMonth();
  const d = day.getDate();
  let number = 0

  const onChange = (e) => {
    const [firstInx, secondInx] = e.detail.value

    const firstValue = valueList[firstInx]
    const secondValue = numberTrave[secondInx]

    const { travelId } = firstValue//行程内容
    const { i } = secondValue//天数


    console.log(firstValue, secondValue);


    if (travelMine.records.total < 0) {
      newTravelMine({ title: `我的行程 ${y}-${m == 0 ? 1 : m}-${d}` }).then(e => {
        console.log("🚀 ~ file: index.jsx ~ line 61 ~ newTravelMine ~ e", e)
        // saveTravel({})
        saveTravel(travelId, { dayOrder: i, targetId: targetId, targetType: 'note' }).then((res) => {
          Taro.
            Taro.showToast({
              title: '添加成功',
              icon: 'none',
              duration: 1000
            })
          console.log(res);
        })
      })
    } else {
      saveTravel(travelId, { dayOrder: i, targetId: targetId, targetType: 'note' }).then((res) => {
        console.log(res);
        Taro.showToast({
          title: '添加成功',
          icon: 'none',

          duration: 1000
        })
      })
      // console.log('else');

    }
  }


  const handlePayClick = () => {
    // Taro.navigateTo({ url: `/pages/PayOrder/index?packageId=${item.packageId}&scene=${scene || ''}&subOrderId=${subOrderId}&id=${id}` })

  }
  const PayAction =
    <View className='view-picker'>
      <Picker
        className='picker-box'
        mode='multiSelector'
        range={array}
        range-key='title'
        onColumnChange={handleColumn}
        onChange={onChange}
        scrollType='link'
      // value={}

      >

        <Action.Icon icon={item.isVisited > 1 ? grassOFF : grassNO} text={item.isVisited > 1 ? '种草' : '已种草'} onClick={handlePayClick} />

      </Picker>

    </View>



  return (
    <View style={{ margin: '15px 5px' }} >
      <View className='packageDetail' style={{ display: goshop ? '' : 'none' }}>
        <Popup show={showCutover} maskClosable={showCutover} onClose={onClose}>
          <ScrollView
            scrollY
            style={{ maxHeight: '60vh' }}
          >
            <Image mode='widthFix' src={item.details ? item.details : item.poster} />
          </ScrollView>
        </Popup >
      </View>
      <CouponCard action={PayAction}>
        <CouponMedia onClick={goFood}>
          <CouponMedia.Header
            cashback={item.cashback}
            image={compressImage(item.poster)}
            badge='note'
          />
          <CouponMedia.Body star={st}>
            <View className='foodCard'>
              <View className='cpn-card-text'>
                {(item.title).toString().length > 25 ? (item.title).substring(0, 25) + '...' : (item.title)}
              </View>
              <View className='cpn-md-act'>
                {/* <Location {...det} /> */}
                <SaveIcon saved={item.isSaved > 0} targetType='shop_package' editable={editable} targetId={item.packageId} />
              </View>
            </View>
          </CouponMedia.Body>
        </CouponMedia>
      </CouponCard>
    </View>
  )
}